import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener {
    Manager M;
    SelectInteger S;
    ListenSquare GO,HALT,VGO,VHALT,SEND;
    int COUNT;
    Lever PACK,P100,P10,P1,S100,S10,S1;
    PointSpreader AN;
    VoronoiDrawer VD;

     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 setScales(250,380,30);
	 AN=new PointSpreader();
	 VD=new VoronoiDrawer();
	 makeControls();
     }


    public void makeControls() {
	GO=new ListenSquare(20,150,70,20);
	HALT=new ListenSquare(120,150,90,20);
	VGO=new ListenSquare(20,200,70,20);
	VHALT=new ListenSquare(120,200,90,20);
	SEND=new ListenSquare(200,250,100,40);
	
	PACK=new Lever(10,60,19,20);

	P100=new Lever(10,20,0,9);
	P10=new Lever(160,20,1,9);
	P1=new Lever(310,20,5,9);
	
	S100=new Lever(10,100,2,9);
	S10=new Lever(160,100,1,9);
	S1=new Lever(310,100,7,9);
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);  
      drawControls(g);
   }

    public void drawControls(Graphics2D g) {
	Color C=new Color(60,100,255);
	SEND.render(g,Color.blue);
	g.setColor(Color.black);
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	if(AN.HALT==true)  GO.render(g,new Color(0,140,0));
	if(AN.HALT==false) HALT.render(g,new Color(160,0,0));
	if(VD.HALT==true)  VGO.render(g,new Color(0,140,0));
	if(VD.HALT==false) VHALT.render(g,new Color(160,0,0));
	g.setColor(new Color(200,200,200));
	g.drawString("evolve",(int)(GO.x+12),(int)(GO.y+15));
	g.drawString("stop evolve",(int)(HALT.x+7),(int)(HALT.y+15));
	g.drawString("voronoi",(int)(VGO.x+12),(int)(VGO.y+15));
	g.drawString("stop voronoi",(int)(VHALT.x+7),(int)(VHALT.y+15));
	
	PACK.render2(g,"concentration",Color.blue);
	P100.render2(g,"pointsX100",Color.blue);
	P10.render2(g,"pointsX10",Color.blue);
	P1.render2(g,"pointsX1",Color.blue);

	Color CC=new Color(0,180,0);
	S100.render2(g,"delayX100",CC);
	S10.render2(g,"delayX10",CC);
	S1.render2(g,"delayX1",CC);

        g.setFont(new Font("Helvetica",Font.PLAIN,20));
	Integer P=new Integer(numberOfPoints());
	g.setColor(Color.black);
	g.drawString(P.toString(),440,32);
	P=new Integer(speed());
	g.drawString(P.toString(),440,112);
	g.setColor(Color.white);
	g.drawString("send",(int)(SEND.x+27),(int)(SEND.y+25));
    }


    public void drawBG(Graphics2D g) {
	g.setColor(new Color(200,200,200));
	g.fillRect(0,0,this.getWidth(),this.getHeight());
    }


    public void doControls(Point X) {
	PACK.process(X);
	P100.process(X);
	P10.process(X);
	P1.process(X);
	S100.process(X);
	S10.process(X);
	S1.process(X);
	if(HALT.inside(X)==1) AN.HALT=true;
	if(VHALT.inside(X)==1) VD.HALT=true;
	if(SEND.inside(X)==1) M.P.setRandom();
	
	if(GO.inside(X)==1) {
	  AN=new PointSpreader();
	  AN.M=this.M;
	  new Thread(AN).start();
	}
	
	if(VGO.inside(X)==1) {
	  VD=new VoronoiDrawer();
	  VD.M=this.M;
	  new Thread(VD).start();
	}
    }	

    public int numberOfPoints() {
	return 100*P100.val+10*P10.val+P1.val;
    }
    
    public int speed() {
	return 100*S100.val+10*S10.val+S1.val;
    }
    
    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	doControls(J.X);
	M.repaint();
    }  

    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   
     public void mouseMoved(MouseEvent e) {}    
     public void mouseDragged(MouseEvent e) {
         
     } 

}

