import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.util.Arrays;


public class VoronoiDrawer implements Runnable {
    Manager M;
    boolean HALT;

    /**This is the general method for creating on of these objects.*/
    public VoronoiDrawer() {
	HALT=true;
    }

    /**This method calls the object and assigns to it a PaintCanvas.
       As this object runs, it modifies the colors on the Picture Canvas.*/

    public VoronoiDrawer(Manager m) {
	this.M =m;
	HALT=true;
    }


    /**Main routine*/
    public void run() {
	HALT=false;
	int i=0;
	int j=0;

	int[][] t=new int[1000][3];
	for(int ii=0;ii<1000;++ii) {
	    for(int jj=0;jj<3;++jj) t[ii][jj]=(int)(255*Math.random());
	}
	
	while(HALT==false) {
	    ++i;
            if(i==500) {
                i=0;++j;
	    }
	    if(j==500) {
		i=0;j=0;
	        try{M.P.repaint();}
		catch(Exception e) {}
	    }

	    Complex z=M.P.unTransform(i,j);

	    /**Tests if the point is in the unit square.*/

	    boolean test=inBox(z);

	    /**If so, then ...*/

	     if(test==true) {
		 int m=M.P.whichCell(z);

		 int[] c=t[m];
		 int col=convert(c);
		 M.P.IMAGE.setRGB(i,j,col);
	    }
	}
    }

    /**Tests if you are in the unit square*/
    public boolean inBox(Complex z) {
	double[] d={z.x,z.y};
	 if(d[0]<=0) return(false);
	 if(d[0]>=1) return(false);
	 if(d[1]<=0) return(false);
	 if(d[1]>=1) return(false);
	return(true);
    }

    /**Coloring: This converts a list of 3 numbers 
       (redval,blueval,greenval)
       into a single integer.*/

    public static int convert(int[] a) {
	int n=256*256*a[0]+256*a[1]+a[2];
	return(n);
    }

    public static int[] getColor(int n) {
	int[][] a={{0,0,0},{255,150,0},{255,0,0},{210,0,0},
                   {180,0,0},{140,0,0},{255,0,100},{255,0,255},
                   {0,255,0},{0,200,0},{0,150,0},{0,100,0},
                   {50,100,255},{0,0,255},{0,0,200},{0,0,150},
                   {0,255,255},{0,200,200},{0,150,150},{0,100,100}};
	return a[n];
    }


}
